Index: /BAORadio/libindi/libindi/libs/indibase/indiccd.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indiccd.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/indiccd.cpp	(revision 642)
@@ -1,21 +1,18 @@
 /*******************************************************************************
-  Copyright(c) 2010 Gerry Rozema. All rights reserved.
-
-  This program is free software; you can redistribute it and/or modify it
-  under the terms of the GNU General Public License as published by the Free
-  Software Foundation; either version 2 of the License, or (at your option)
-  any later version.
-
-  This program is distributed in the hope that it will be useful, but WITHOUT
-  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
-  more details.
-
-  You should have received a copy of the GNU General Public License along with
-  this program; if not, write to the Free Software Foundation, Inc., 59
-  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
-
-  The full GNU General Public License is included in this distribution in the
-  file called LICENSE.
+  Copyright(c) 2010, 2011 Gerry Rozema, Jasem Mutlaq. All rights reserved.
+
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
+
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
 *******************************************************************************/
 
@@ -24,126 +21,232 @@
 #include <string.h>
 
-#include <fitsio.h>
 #include <zlib.h>
 
+const char *IMAGE_SETTINGS_TAB = "Image Settings";
+const char *IMAGE_INFO_TAB     = "Image Info";
+const char *GUIDE_HEAD_TAB     = "Guide Head";
+const char *GUIDE_CONTROL_TAB     = "Guider Control";
+
+CCDChip::CCDChip()
+{
+    SendCompressed=false;
+    Interlaced=false;
+
+    RawFrame=NULL;
+    RawFrameSize=0;
+
+    FrameType=LIGHT_FRAME;
+
+    ImageFrameNP = new INumberVectorProperty;
+    FrameTypeSP = new ISwitchVectorProperty;
+    ImageExposureNP = new INumberVectorProperty;
+    ImageBinNP = new INumberVectorProperty;
+    ImagePixelSizeNP = new INumberVectorProperty;
+    CompressSP = new ISwitchVectorProperty;
+    FitsBP = new IBLOBVectorProperty;
+
+}
+
+CCDChip::~CCDChip()
+{
+    delete RawFrame;
+    RawFrameSize=0;
+    RawFrame=NULL;
+
+    delete ImageFrameNP;
+    delete FrameTypeSP;
+    delete ImageExposureNP;
+    delete ImageBinNP;
+    delete ImagePixelSizeNP;
+    delete CompressSP;
+    delete FitsBP;
+}
+
+int CCDChip::setFrameType(CCD_FRAME t)
+{
+    //fprintf(stderr,"Set frame type to %d\n",t);
+    FrameType=t;
+    return 0;
+}
+
+void CCDChip::setResolutoin(int x, int y)
+{
+    XRes = x;
+    YRes = y;
+
+    ImagePixelSizeN[0].value=x;
+    ImagePixelSizeN[1].value=y;
+
+    IDSetNumber(ImagePixelSizeNP, NULL);
+}
+
+void CCDChip::setFrame(int subx, int suby, int subw, int subh)
+{
+    SubX = subx;
+    SubY = suby;
+    SubW = subw;
+    SubH = subh;
+
+    ImageFrameN[0].value = SubX;
+    ImageFrameN[1].value = SubY;
+    ImageFrameN[2].value = SubW;
+    ImageFrameN[3].value = SubH;
+
+    IDSetNumber(ImageFrameNP, NULL);
+}
+
+void CCDChip::setBin(int hor, int ver)
+{
+    BinX = hor;
+    BinY = ver;
+
+    ImageBinN[0].value = BinX;
+    ImageBinN[1].value = BinY;
+
+    IDSetNumber(ImageBinNP, NULL);
+}
+
+void CCDChip::setPixelSize(int x, int y)
+{
+    PixelSizex = x;
+    PixelSizey = y;
+
+    ImagePixelSizeN[2].value=x;
+    ImagePixelSizeN[3].value=x;
+    ImagePixelSizeN[4].value=y;
+
+    IDSetNumber(ImagePixelSizeNP, NULL);
+
+}
+
+void CCDChip::setBPP(int bbp)
+{
+    BPP = bbp;
+
+    ImagePixelSizeN[5].value = BPP;
+
+    IDSetNumber(ImagePixelSizeNP, NULL);
+}
+
+void CCDChip::setFrameBufferSize(int nbuf)
+{
+    if (RawFrame != NULL)
+        delete RawFrame;
+
+    RawFrameSize = nbuf;
+
+    RawFrame = new char[nbuf];
+}
+
+void CCDChip::setExposure(double duration)
+{
+    ImageExposureN[0].value = duration;
+    IDSetNumber(ImageExposureNP, NULL);
+}
+
+void CCDChip::setInterlaced(bool intr)
+{
+    Interlaced = intr;
+}
+
+void CCDChip::setExposureFailed()
+{
+    ImageExposureNP->s = IPS_ALERT;
+    IDSetNumber(ImageExposureNP, NULL);
+}
+
 INDI::CCD::CCD()
 {
     //ctor
-    SendCompressed=false;
-    GuiderCompressed=false;
     HasGuideHead=false;
     HasSt4Port=false;
-
-    RawFrame=NULL;
-    RawFrameSize=0;
-
-    RawGuideSize=0;
-    RawGuiderFrame=NULL;
-
-    FrameType=FRAME_TYPE_LIGHT;
-
+    InExposure=false;
+    TelescopeTP = new ITextVectorProperty;
 }
 
 INDI::CCD::~CCD()
 {
-    //dtor
+    delete TelescopeTP;
 }
 
 bool INDI::CCD::initProperties()
 {
-    //IDLog("INDI::CCD initProperties '%s'\n",deviceName());
-
     DefaultDriver::initProperties();   //  let the base class flesh in what it wants
 
-    //IDLog("INDI::CCD::initProperties()\n");
-    IUFillNumber(&ImageFrameN[0],"X","Left ","%4.0f",0,1392.0,0,0);
-    IUFillNumber(&ImageFrameN[1],"Y","Top","%4.0f",0,1040,0,0);
-    IUFillNumber(&ImageFrameN[2],"WIDTH","Width","%4.0f",0,1392.0,0,1392.0);
-    IUFillNumber(&ImageFrameN[3],"HEIGHT","Height","%4.0f",0,1040,0,1040);
-    IUFillNumberVector(&ImageFrameNV,ImageFrameN,4,deviceName(),"CCD_FRAME","Frame","Image Settings",IP_RW,60,IPS_IDLE);
-
-    IUFillSwitch(&FrameTypeS[0],"FRAME_LIGHT","Light",ISS_ON);
-    IUFillSwitch(&FrameTypeS[1],"FRAME_BIAS","Bias",ISS_OFF);
-    IUFillSwitch(&FrameTypeS[2],"FRAME_DARK","Dark",ISS_OFF);
-    IUFillSwitch(&FrameTypeS[3],"FRAME_FLAT","Flat",ISS_OFF);
-    IUFillSwitchVector(&FrameTypeSV,FrameTypeS,4,deviceName(),"CCD_FRAME_TYPE","FrameType","Image Settings",IP_RW,ISR_1OFMANY,60,IPS_IDLE);
-
-    IUFillNumber(&ImageExposureN[0],"CCD_EXPOSURE_VALUE","Duration (s)","%5.2f",0,36000,0,1.0);
-    IUFillNumberVector(&ImageExposureNV,ImageExposureN,1,deviceName(),"CCD_EXPOSURE","Expose","Main Control",IP_RW,60,IPS_IDLE);
-    //IUFillNumber(&CcdExposureReqN[0],"CCD_EXPOSURE_VALUE","Duration","%5.2f",0,36000,0,1.0);
-    //IUFillNumberVector(&CcdExposureReqNV,CcdExposureReqN,1,deviceName(),"CCD_EXPOSURE_REQUEST","Expose","Main Control",IP_WO,60,IPS_IDLE);
-
-    IUFillNumber(&ImageBinN[0],"HOR_BIN","X","%2.0f",1,4,1,1);
-    IUFillNumber(&ImageBinN[1],"VER_BIN","Y","%2.0f",1,4,1,1);
-    IUFillNumberVector(&ImageBinNV,ImageBinN,2,deviceName(),"CCD_BINNING","Binning","Image Settings",IP_RW,60,IPS_IDLE);
-
-    IUFillNumber(&ImagePixelSizeN[0],"CCD_MAX_X","Resolution x","%4.0f",1,40,0,6.45);
-    IUFillNumber(&ImagePixelSizeN[1],"CCD_MAX_Y","Resolution y","%4.0f",1,40,0,6.45);
-    IUFillNumber(&ImagePixelSizeN[2],"CCD_PIXEL_SIZE","Pixel size (um)","%5.2f",1,40,0,6.45);
-    IUFillNumber(&ImagePixelSizeN[3],"CCD_PIXEL_SIZE_X","Pixel size X","%5.2f",1,40,0,6.45);
-    IUFillNumber(&ImagePixelSizeN[4],"CCD_PIXEL_SIZE_Y","Pixel size Y","%5.2f",1,40,0,6.45);
-    IUFillNumber(&ImagePixelSizeN[5],"CCD_BITSPERPIXEL","Bits per pixel","%3.0f",1,40,0,6.45);
-    IUFillNumberVector(&ImagePixelSizeNV,ImagePixelSizeN,6,deviceName(),"CCD_INFO","Ccd Information","Image Info",IP_RO,60,IPS_IDLE);
-
-
-
-    IUFillNumber(&GuiderFrameN[0],"X","Left ","%4.0f",0,1392.0,0,0);
-    IUFillNumber(&GuiderFrameN[1],"Y","Top","%4.0f",0,1040,0,0);
-    IUFillNumber(&GuiderFrameN[2],"WIDTH","Width","%4.0f",0,1392.0,0,1392.0);
-    IUFillNumber(&GuiderFrameN[3],"HEIGHT","Height","%4.0f",0,1040,0,1040);
-    IUFillNumberVector(&GuiderFrameNV,GuiderFrameN,4,deviceName(),"GUIDER_FRAME","Frame","Guidehead Settings",IP_RW,60,IPS_IDLE);
-
-
-    IUFillNumber(&GuiderPixelSizeN[0],"GUIDER_MAX_X","Resolution x","%4.0f",1,40,0,6.45);
-    IUFillNumber(&GuiderPixelSizeN[1],"GUIDER_MAX_Y","Resolution y","%4.0f",1,40,0,6.45);
-    IUFillNumber(&GuiderPixelSizeN[2],"GUIDER_PIXEL_SIZE","Pixel size (um)","%5.2f",1,40,0,6.45);
-    IUFillNumber(&GuiderPixelSizeN[3],"GUIDER_PIXEL_SIZE_X","Pixel size X","%5.2f",1,40,0,6.45);
-    IUFillNumber(&GuiderPixelSizeN[4],"GUIDER_PIXEL_SIZE_Y","Pixel size Y","%5.2f",1,40,0,6.45);
-    IUFillNumber(&GuiderPixelSizeN[5],"GUIDER_BITSPERPIXEL","Bits per pixel","%3.0f",1,40,0,6.45);
-    IUFillNumberVector(&GuiderPixelSizeNV,GuiderPixelSizeN,6,deviceName(),"GUIDER_INFO","Guidehead Information","Guidehead Info",IP_RO,60,IPS_IDLE);
-
-
-    IUFillNumber(&GuiderExposureN[0],"GUIDER_EXPOSURE_VALUE","Duration (s)","%5.2f",0,36000,0,1.0);
-    IUFillNumberVector(&GuiderExposureNV,GuiderExposureN,1,deviceName(),"GUIDER_EXPOSURE","Guider","Main Cntrol",IP_RW,60,IPS_IDLE);
-
-
-    IUFillSwitch(&GuiderVideoS[0],"ON","on",ISS_OFF);
-    IUFillSwitch(&GuiderVideoS[1],"OFF","off",ISS_OFF);
-    IUFillSwitchVector(&GuiderVideoSV,GuiderVideoS,2,deviceName(),"VIDEO_STREAM","Guider Stream","Guidehead Settings",IP_RW,ISR_1OFMANY,60,IPS_IDLE);
-
-    //IDLog("Setting up blob\n");
-
-    IUFillSwitch(&CompressS[0],"COMPRESS","Compress",ISS_OFF);
-    IUFillSwitch(&CompressS[1],"RAW","Raw",ISS_ON);
-    IUFillSwitchVector(&CompressSV,CompressS,2,deviceName(),"COMPRESSION","Image","Data Channel",IP_RW,ISR_1OFMANY,60,IPS_IDLE);
-
-    IUFillSwitch(&GuiderCompressS[0],"GCOMPRESS","Compress",ISS_OFF);
-    IUFillSwitch(&GuiderCompressS[1],"GRAW","Raw",ISS_ON);
-    IUFillSwitchVector(&GuiderCompressSV,GuiderCompressS,2,deviceName(),"GCOMPRESSION","Guider","Data Channel",IP_RW,ISR_1OFMANY,60,IPS_IDLE);
-
-    IUFillBLOB(&FitsB,"CCD1","Image","");
-    IUFillBLOBVector(&FitsBV,&FitsB,1,deviceName(),"CCD1","Image Data","Data Channel",IP_RO,60,IPS_IDLE);
-
-    IUFillBLOB(&GuiderB,"CCD2","Guider","");
-    IUFillBLOBVector(&GuiderBV,&GuiderB,1,deviceName(),"CCD2","Guider Data","Data Channel",IP_RO,60,IPS_IDLE);
-
-    IUFillNumber(&GuideNS[0],"TIMED_GUIDE_N","North (sec)","%g",0,10,0.001,0);
-    IUFillNumber(&GuideNS[1],"TIMED_GUIDE_S","South (sec)","%g",0,10,0.001,0);
-    IUFillNumberVector(&GuideNSV,GuideNS,2,deviceName(),"TELESCOPE_TIMED_GUIDE_NS","Guide North/South","GuiderControl",IP_RW,60,IPS_IDLE);
-
-    IUFillNumber(&GuideEW[0],"TIMED_GUIDE_E","East (sec)","%g",0,10,0.001,0);
-    IUFillNumber(&GuideEW[1],"TIMED_GUIDE_W","West (sec)","%g",0,10,0.001,0);
-    IUFillNumberVector(&GuideEWV,GuideEW,2,deviceName(),"TELESCOPE_TIMED_GUIDE_WE","Guide East/West","GuiderControl",IP_RW,60,IPS_IDLE);
-
-
-    //IDLog("Setting up ccdpreview stuff\n");
-    //IUFillNumber(&GuiderN[0],"WIDTH","Width","%4.0f",0.,1392.0,0.,1392.);
-    //IUFillNumber(&GuiderN[1],"HEIGHT","Height","%4.0f",0.,1040.,0.,1040.);
-    //IUFillNumber(&GuiderN[2],"MAXGOODDATA","max good","%5.0f",0.,65535.0,0.,65535.0);
-    //IUFillNumber(&GuiderN[3],"BYTESPERPIXEL","BPP","%1.0f",1.,4.,1.,2.);
-    //IUFillNumber(&GuiderN[4],"BYTEORDER","BO","%1.0f",1.,2.,1.,1.);
-    //IUFillNumberVector(&GuiderNV,GuiderN,5,deviceName(),"CCDPREVIEW_CTRL","Image Size","Guider Settings",IP_RW,60,IPS_IDLE);
-
-    return 0;
+    // PRIMARY CCD Init
+
+    IUFillNumber(&PrimaryCCD.ImageFrameN[0],"X","Left ","%4.0f",0,1392.0,0,0);
+    IUFillNumber(&PrimaryCCD.ImageFrameN[1],"Y","Top","%4.0f",0,1040,0,0);
+    IUFillNumber(&PrimaryCCD.ImageFrameN[2],"WIDTH","Width","%4.0f",0,1392.0,0,1392.0);
+    IUFillNumber(&PrimaryCCD.ImageFrameN[3],"HEIGHT","Height","%4.0f",0,1040,0,1040);
+    IUFillNumberVector(PrimaryCCD.ImageFrameNP,PrimaryCCD.ImageFrameN,4,deviceName(),"CCD_FRAME","Frame",IMAGE_SETTINGS_TAB,IP_RW,60,IPS_IDLE);
+
+    IUFillSwitch(&PrimaryCCD.FrameTypeS[0],"FRAME_LIGHT","Light",ISS_ON);
+    IUFillSwitch(&PrimaryCCD.FrameTypeS[1],"FRAME_BIAS","Bias",ISS_OFF);
+    IUFillSwitch(&PrimaryCCD.FrameTypeS[2],"FRAME_DARK","Dark",ISS_OFF);
+    IUFillSwitch(&PrimaryCCD.FrameTypeS[3],"FRAME_FLAT","Flat",ISS_OFF);
+    IUFillSwitchVector(PrimaryCCD.FrameTypeSP,PrimaryCCD.FrameTypeS,4,deviceName(),"CCD_FRAME_TYPE","FrameType",IMAGE_SETTINGS_TAB,IP_RW,ISR_1OFMANY,60,IPS_IDLE);
+
+    IUFillNumber(&PrimaryCCD.ImageExposureN[0],"CCD_EXPOSURE_VALUE","Duration (s)","%5.2f",0,36000,0,1.0);
+    IUFillNumberVector(PrimaryCCD.ImageExposureNP,PrimaryCCD.ImageExposureN,1,deviceName(),"CCD_EXPOSURE_REQUEST","Expose",MAIN_CONTROL_TAB,IP_RW,60,IPS_IDLE);
+
+    IUFillNumber(&PrimaryCCD.ImageBinN[0],"HOR_BIN","X","%2.0f",1,4,1,1);
+    IUFillNumber(&PrimaryCCD.ImageBinN[1],"VER_BIN","Y","%2.0f",1,4,1,1);
+    IUFillNumberVector(PrimaryCCD.ImageBinNP,PrimaryCCD.ImageBinN,2,deviceName(),"CCD_BINNING","Binning",IMAGE_SETTINGS_TAB,IP_RW,60,IPS_IDLE);
+
+    IUFillNumber(&PrimaryCCD.ImagePixelSizeN[0],"CCD_MAX_X","Resolution x","%4.0f",1,40,0,6.45);
+    IUFillNumber(&PrimaryCCD.ImagePixelSizeN[1],"CCD_MAX_Y","Resolution y","%4.0f",1,40,0,6.45);
+    IUFillNumber(&PrimaryCCD.ImagePixelSizeN[2],"CCD_PIXEL_SIZE","Pixel size (um)","%5.2f",1,40,0,6.45);
+    IUFillNumber(&PrimaryCCD.ImagePixelSizeN[3],"CCD_PIXEL_SIZE_X","Pixel size X","%5.2f",1,40,0,6.45);
+    IUFillNumber(&PrimaryCCD.ImagePixelSizeN[4],"CCD_PIXEL_SIZE_Y","Pixel size Y","%5.2f",1,40,0,6.45);
+    IUFillNumber(&PrimaryCCD.ImagePixelSizeN[5],"CCD_BITSPERPIXEL","Bits per pixel","%3.0f",1,40,0,6.45);
+    IUFillNumberVector(PrimaryCCD.ImagePixelSizeNP,PrimaryCCD.ImagePixelSizeN,6,deviceName(),"CCD_INFO","Ccd Information",IMAGE_INFO_TAB,IP_RO,60,IPS_IDLE);
+
+    IUFillSwitch(&PrimaryCCD.CompressS[0],"COMPRESS","Compress",ISS_OFF);
+    IUFillSwitch(&PrimaryCCD.CompressS[1],"RAW","Raw",ISS_ON);
+    IUFillSwitchVector(PrimaryCCD.CompressSP,PrimaryCCD.CompressS,2,deviceName(),"COMPRESSION","Image",IMAGE_SETTINGS_TAB,IP_RW,ISR_1OFMANY,60,IPS_IDLE);
+
+    IUFillBLOB(&PrimaryCCD.FitsB,"CCD1","Image","");
+    IUFillBLOBVector(PrimaryCCD.FitsBP,&PrimaryCCD.FitsB,1,deviceName(),"CCD1","Image Data",OPTIONS_TAB,IP_RO,60,IPS_IDLE);
+
+    // GUIDER CCD Init
+
+    IUFillNumber(&GuideCCD.ImageFrameN[0],"X","Left ","%4.0f",0,1392.0,0,0);
+    IUFillNumber(&GuideCCD.ImageFrameN[1],"Y","Top","%4.0f",0,1040,0,0);
+    IUFillNumber(&GuideCCD.ImageFrameN[2],"WIDTH","Width","%4.0f",0,1392.0,0,1392.0);
+    IUFillNumber(&GuideCCD.ImageFrameN[3],"HEIGHT","Height","%4.0f",0,1040,0,1040);
+    IUFillNumberVector(GuideCCD.ImageFrameNP,GuideCCD.ImageFrameN,4,deviceName(),"GUIDE_FRAME","Frame",GUIDE_HEAD_TAB,IP_RW,60,IPS_IDLE);
+
+    IUFillNumber(&GuideCCD.ImagePixelSizeN[0],"Image_MAX_X","Resolution x","%4.0f",1,40,0,6.45);
+    IUFillNumber(&GuideCCD.ImagePixelSizeN[1],"Image_MAX_Y","Resolution y","%4.0f",1,40,0,6.45);
+    IUFillNumber(&GuideCCD.ImagePixelSizeN[2],"Image_PIXEL_SIZE","Pixel size (um)","%5.2f",1,40,0,6.45);
+    IUFillNumber(&GuideCCD.ImagePixelSizeN[3],"Image_PIXEL_SIZE_X","Pixel size X","%5.2f",1,40,0,6.45);
+    IUFillNumber(&GuideCCD.ImagePixelSizeN[4],"Image_PIXEL_SIZE_Y","Pixel size Y","%5.2f",1,40,0,6.45);
+    IUFillNumber(&GuideCCD.ImagePixelSizeN[5],"Image_BITSPERPIXEL","Bits per pixel","%3.0f",1,40,0,6.45);
+    IUFillNumberVector(GuideCCD.ImagePixelSizeNP,GuideCCD.ImagePixelSizeN,6,deviceName(),"GUIDE_INFO",GUIDE_HEAD_TAB,GUIDE_HEAD_TAB,IP_RO,60,IPS_IDLE);
+
+    IUFillNumber(&GuideCCD.ImageExposureN[0],"GUIDER_EXPOSURE_VALUE","Duration (s)","%5.2f",0,36000,0,1.0);
+    IUFillNumberVector(GuideCCD.ImageExposureNP,GuideCCD.ImageExposureN,1,deviceName(),"GUIDER_EXPOSURE","Image",MAIN_CONTROL_TAB,IP_RW,60,IPS_IDLE);
+
+    IUFillSwitch(&GuideCCD.CompressS[0],"GCOMPRESS","Compress",ISS_OFF);
+    IUFillSwitch(&GuideCCD.CompressS[1],"GRAW","Raw",ISS_ON);
+    IUFillSwitchVector(GuideCCD.CompressSP,GuideCCD.CompressS,2,deviceName(),"GCOMPRESSION","Image",GUIDE_HEAD_TAB,IP_RW,ISR_1OFMANY,60,IPS_IDLE);
+
+    IUFillBLOB(&GuideCCD.FitsB,"CCD2","Guider Image","");
+    IUFillBLOBVector(GuideCCD.FitsBP,&GuideCCD.FitsB,1,deviceName(),"CCD2","Image Data",OPTIONS_TAB,IP_RO,60,IPS_IDLE);
+
+    // CCD Class Init
+
+    IUFillText(&TelescopeT[0],"ACTIVE_TELESCOPE","Telescope","");
+    IUFillTextVector(TelescopeTP,TelescopeT,1,deviceName(),"ACTIVE_DEVICES","Snoop Scope",OPTIONS_TAB,IP_RW,60,IPS_IDLE);
+
+    IUFillNumber(&EqN[0],"RA_PEC","Ra (hh:mm:ss)","%010.6m",0,24,0,0);
+    IUFillNumber(&EqN[1],"DEC_PEC","Dec (dd:mm:ss)","%010.6m",-90,90,0,0);
+    IUFillNumberVector(&EqNP,EqN,2,"","EQUATORIAL_PEC","EQ PEC","Main Control",IP_RW,60,IPS_IDLE);
+
+    // Guider Interface
+    initGuiderProperties(deviceName(), GUIDE_CONTROL_TAB);
+
+    return true;
 }
 
@@ -162,67 +265,127 @@
 {
     //IDLog("INDI::CCD UpdateProperties isConnected returns %d %d\n",isConnected(),Connected);
-    if(isConnected()) {
-        defineNumber(&ImageExposureNV);
-        defineNumber(&ImageFrameNV);
-        defineNumber(&ImageBinNV);
-
-
-        if(HasGuideHead) {
+    if(isConnected())
+    {
+        defineNumber(PrimaryCCD.ImageExposureNP);
+        defineNumber(PrimaryCCD.ImageFrameNP);
+        defineNumber(PrimaryCCD.ImageBinNP);
+
+        if(HasGuideHead)
+        {
             IDLog("Sending Guider Stuff\n");
-            defineNumber(&GuiderExposureNV);
-            defineNumber(&GuiderFrameNV);
-            defineSwitch(&GuiderVideoSV);
-        }
-
-        defineNumber(&ImagePixelSizeNV);
-        if(HasGuideHead) {
-            defineNumber(&GuiderPixelSizeNV);
-        }
-        defineSwitch(&CompressSV);
-        defineBLOB(&FitsBV);
+            defineNumber(GuideCCD.ImageExposureNP);
+            defineNumber(GuideCCD.ImageFrameNP);
+        }
+
+        defineNumber(PrimaryCCD.ImagePixelSizeNP);
         if(HasGuideHead)
         {
-            defineSwitch(&GuiderCompressSV);
-            defineBLOB(&GuiderBV);
+            defineNumber(GuideCCD.ImagePixelSizeNP);
+        }
+        defineSwitch(PrimaryCCD.CompressSP);
+        defineBLOB(PrimaryCCD.FitsBP);
+        if(HasGuideHead)
+        {
+            defineSwitch(GuideCCD.CompressSP);
+            defineBLOB(GuideCCD.FitsBP);
         }
         if(HasSt4Port)
         {
-            defineNumber(&GuideNSV);
-            defineNumber(&GuideEWV);
-        }
-        defineSwitch(&FrameTypeSV);
-    } else {
-        deleteProperty(ImageFrameNV.name);
-        deleteProperty(ImageBinNV.name);
-        deleteProperty(ImagePixelSizeNV.name);
-        deleteProperty(ImageExposureNV.name);
-        deleteProperty(FitsBV.name);
-        deleteProperty(CompressSV.name);
-        if(HasGuideHead) {
-            deleteProperty(GuiderVideoSV.name);
-            deleteProperty(GuiderExposureNV.name);
-            deleteProperty(GuiderFrameNV.name);
-            deleteProperty(GuiderPixelSizeNV.name);
-            deleteProperty(GuiderBV.name);
-            deleteProperty(GuiderCompressSV.name);
-        }
-        if(HasSt4Port) {
-            deleteProperty(GuideNSV.name);
-            deleteProperty(GuideEWV.name);
-
-        }
-        deleteProperty(FrameTypeSV.name);
+            defineNumber(GuideNSP);
+            defineNumber(GuideEWP);
+        }
+        defineSwitch(PrimaryCCD.FrameTypeSP);
+        defineText(TelescopeTP);
+    }
+    else
+    {
+        deleteProperty(PrimaryCCD.ImageFrameNP->name);
+        deleteProperty(PrimaryCCD.ImageBinNP->name);
+        deleteProperty(PrimaryCCD.ImagePixelSizeNP->name);
+        deleteProperty(PrimaryCCD.ImageExposureNP->name);
+        deleteProperty(PrimaryCCD.FitsBP->name);
+        deleteProperty(PrimaryCCD.CompressSP->name);
+        if(HasGuideHead)
+        {
+            deleteProperty(GuideCCD.ImageExposureNP->name);
+            deleteProperty(GuideCCD.ImageFrameNP->name);
+            deleteProperty(GuideCCD.ImagePixelSizeNP->name);
+            deleteProperty(GuideCCD.FitsBP->name);
+            deleteProperty(GuideCCD.CompressSP->name);
+        }
+        if(HasSt4Port)
+        {
+            deleteProperty(GuideNSP->name);
+            deleteProperty(GuideEWP->name);
+
+        }
+        deleteProperty(PrimaryCCD.FrameTypeSP->name);
+        deleteProperty(TelescopeTP->name);
     }
     return true;
 }
 
+void INDI::CCD::ISSnoopDevice (XMLEle *root)
+ {
+     //fprintf(stderr," ################# CCDSim handling snoop ##############\n");
+     if(IUSnoopNumber(root,&EqNP)==0)
+     {
+        float newra,newdec;
+        newra=EqN[0].value;
+        newdec=EqN[1].value;
+        if((newra != RA)||(newdec != Dec))
+        {
+            //fprintf(stderr,"RA %4.2f  Dec %4.2f Snooped RA %4.2f  Dec %4.2f\n",RA,Dec,newra,newdec);
+            RA=newra;
+            Dec=newdec;
+
+        }
+     }
+     else
+     {
+        //fprintf(stderr,"Snoop Failed\n");
+     }
+ }
+
+bool INDI::CCD::ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n)
+{
+    //  Ok, lets see if this is a property wer process
+    //IDLog("IndiTelescope got %d new text items name %s\n",n,name);
+    //  first check if it's for our device
+    if(strcmp(dev,deviceName())==0)
+    {
+        //  This is for our device
+        //  Now lets see if it's something we process here
+        if(strcmp(name,TelescopeTP->name)==0)
+        {
+            int rc;
+            //IDLog("calling update text\n");
+            TelescopeTP->s=IPS_OK;
+            rc=IUUpdateText(TelescopeTP,texts,names,n);
+            //IDLog("update text returns %d\n",rc);
+            //  Update client display
+            IDSetText(TelescopeTP,NULL);
+            saveConfig();
+            IUFillNumberVector(&EqNP,EqN,2,TelescopeT[0].text,"EQUATORIAL_PEC","EQ PEC",MAIN_CONTROL_TAB,IP_RW,60,IPS_IDLE);
+            IDSnoopDevice(TelescopeT[0].text,"EQUATORIAL_PEC");
+            //  We processed this one, so, tell the world we did it
+            return true;
+        }
+
+    }
+
+    return INDI::DefaultDriver::ISNewText(dev,name,texts,names,n);
+}
+
 bool INDI::CCD::ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n)
 {
     //  first check if it's for our device
     //IDLog("INDI::CCD::ISNewNumber %s\n",name);
-    if(strcmp(dev,deviceName())==0) {
+    if(strcmp(dev,deviceName())==0)
+    {
         //  This is for our device
         //  Now lets see if it's something we process here
-        if(strcmp(name,"CCD_EXPOSURE")==0) {
+        if(strcmp(name,"CCD_EXPOSURE_REQUEST")==0)
+        {
             float n;
             int rc;
@@ -230,6 +393,10 @@
             n=values[0];
 
-            ImageExposureN[0].value=n;
-            ImageExposureNV.s=IPS_BUSY;
+            PrimaryCCD.ImageExposureN[0].value=n;
+
+            if (PrimaryCCD.ImageExposureNP->s==IPS_BUSY)
+                AbortExposure();
+
+            PrimaryCCD.ImageExposureNP->s=IPS_BUSY;
             //  now we have a new number, this is our requested exposure time
             //  Tell the clients we are busy with this exposure
@@ -237,20 +404,22 @@
             //  And now call the physical hardware layer to start the exposure
             rc=StartExposure(n);
-            switch(rc) {
+            switch(rc)
+            {
                 case 0: //  normal case, exposure running on timers, callbacks when it's finished
-                    ImageExposureNV.s=IPS_BUSY;
+                    PrimaryCCD.ImageExposureNP->s=IPS_BUSY;
                     break;
                 case 1: //  Short exposure, it's already done
-                    ImageExposureNV.s=IPS_OK;
+                    PrimaryCCD.ImageExposureNP->s=IPS_OK;
                     break;
                 case -1:    //  error condition
-                    ImageExposureNV.s=IPS_ALERT;
+                    PrimaryCCD.ImageExposureNP->s=IPS_ALERT;
                 break;
             }
-            IDSetNumber(&ImageExposureNV,NULL);
-            return true;
-        }
-
-        if(strcmp(name,"GUIDER_EXPOSURE")==0) {
+            IDSetNumber(PrimaryCCD.ImageExposureNP,NULL);
+            return true;
+        }
+
+        if(strcmp(name,"GUIDER_EXPOSURE")==0)
+        {
             float n;
             int rc;
@@ -258,6 +427,6 @@
             n=values[0];
 
-            GuiderExposureN[0].value=n;
-            GuiderExposureNV.s=IPS_BUSY;
+            GuideCCD.ImageExposureN[0].value=n;
+            GuideCCD.ImageExposureNP->s=IPS_BUSY;
             //  now we have a new number, this is our requested exposure time
             //  Tell the clients we are busy with this exposure
@@ -270,69 +439,86 @@
             switch(rc) {
                 case 0: //  normal case, exposure running on timers, callbacks when it's finished
-                    GuiderExposureNV.s=IPS_BUSY;
+                    GuideCCD.ImageExposureNP->s=IPS_BUSY;
                     break;
                 case 1: //  Short exposure, it's already done
-                    GuiderExposureNV.s=IPS_OK;
+                    GuideCCD.ImageExposureNP->s=IPS_OK;
                     break;
                 case -1:    //  error condition
-                    GuiderExposureNV.s=IPS_ALERT;
+                    GuideCCD.ImageExposureNP->s=IPS_ALERT;
                 break;
             }
-            IDSetNumber(&GuiderExposureNV,NULL);
-            return true;
-        }
-        if(strcmp(name,"CCD_BINNING")==0) {
+            IDSetNumber(GuideCCD.ImageExposureNP,NULL);
+            return true;
+        }
+
+        if(strcmp(name,"CCD_BINNING")==0)
+        {
             //  We are being asked to set camera binning
-            ImageBinNV.s=IPS_OK;
-            IUUpdateNumber(&ImageBinNV,values,names,n);
+            PrimaryCCD.ImageBinNP->s=IPS_OK;
+            IUUpdateNumber(PrimaryCCD.ImageBinNP,values,names,n);
+
+            // Let child classes know of CCD BIN changes
+            // If child processes and updates bin (true) then no further action is needed
+            // if child class does not do any processing, then we simply update the values.
+            if (updateCCDBin(PrimaryCCD.ImageBinN[0].value, PrimaryCCD.ImageBinN[1].value) == false)
+                PrimaryCCD.setBin(PrimaryCCD.ImageBinN[0].value, PrimaryCCD.ImageBinN[1].value);
+
+            return true;
+
+        }
+
+        if(strcmp(name,"CCD_FRAME")==0)
+        {
+            //  We are being asked to set camera binning
+            PrimaryCCD.ImageFrameNP->s=IPS_OK;
+            IUUpdateNumber(PrimaryCCD.ImageFrameNP,values,names,n);
             //  Update client display
-            IDSetNumber(&ImageBinNV,NULL);
-
-            //IDLog("Binning set to %4.0f x %4.0f\n",CcdBinN[0].value,CcdBinN[1].value);
-            BinX=ImageBinN[0].value;
-            BinY=ImageBinN[1].value;
-        }
-        if(strcmp(name,"CCD_FRAME")==0) {
+            //IDSetNumber(PrimaryCCD.ImageFrameNP,NULL);
+
+            //IDLog("Frame set to %4.0f,%4.0f %4.0f x %4.0f\n",CcdFrameN[0].value,CcdFrameN[1].value,CcdFrameN[2].value,CcdFrameN[3].value);
+            //SubX=PrimaryCCD.ImageFrameN[0].value;
+            //SubY=PrimaryCCD.ImageFrameN[1].value;
+            //SubW=PrimaryCCD.ImageFrameN[2].value;
+            //SubH=PrimaryCCD.ImageFrameN[3].value;
+
+            if (updateCCDFrame(PrimaryCCD.ImageFrameN[0].value, PrimaryCCD.ImageFrameN[1].value, PrimaryCCD.ImageFrameN[2].value,
+                               PrimaryCCD.ImageFrameN[3].value) == false)
+                PrimaryCCD.setFrame(PrimaryCCD.ImageFrameN[0].value, PrimaryCCD.ImageFrameN[1].value, PrimaryCCD.ImageFrameN[2].value,
+                                    PrimaryCCD.ImageFrameN[3].value);
+            return true;
+        }
+
+        if(strcmp(name,"GUIDER_FRAME")==0)
+        {
             //  We are being asked to set camera binning
-            ImageFrameNV.s=IPS_OK;
-            IUUpdateNumber(&ImageFrameNV,values,names,n);
+            GuideCCD.ImageFrameNP->s=IPS_OK;
+            IUUpdateNumber(GuideCCD.ImageFrameNP,values,names,n);
             //  Update client display
-            IDSetNumber(&ImageFrameNV,NULL);
-
-            //IDLog("Frame set to %4.0f,%4.0f %4.0f x %4.0f\n",CcdFrameN[0].value,CcdFrameN[1].value,CcdFrameN[2].value,CcdFrameN[3].value);
-            SubX=ImageFrameN[0].value;
-            SubY=ImageFrameN[1].value;
-            SubW=ImageFrameN[2].value;
-            SubH=ImageFrameN[3].value;
-            return true;
-        }
-
-        if(strcmp(name,"GUIDER_FRAME")==0) {
-            //  We are being asked to set camera binning
-            GuiderFrameNV.s=IPS_OK;
-            IUUpdateNumber(&GuiderFrameNV,values,names,n);
+            //IDSetNumber(GuiderFrameNP,NULL);
+
+            IDLog("GuiderFrame set to %4.0f,%4.0f %4.0f x %4.0f\n",
+                  GuideCCD.ImageFrameN[0].value,GuideCCD.ImageFrameN[1].value,GuideCCD.ImageFrameN[2].value,GuideCCD.ImageFrameN[3].value);
+            //GSubX=GuiderFrameN[0].value;
+            //GSubY=GuiderFrameN[1].value;
+            //GSubW=GuiderFrameN[2].value;
+            //GSubH=GuiderFrameN[3].value;
+            GuideCCD.setFrame(GuideCCD.ImageFrameN[0].value, GuideCCD.ImageFrameN[1].value,
+                              GuideCCD.ImageFrameN[2].value,GuideCCD.ImageFrameN[3].value);
+
+            return true;
+        }
+
+        if(strcmp(name,GuideNSP->name)==0)
+        {
+            //  We are being asked to send a guide pulse north/south on the st4 port
+            GuideNSP->s=IPS_BUSY;
+            IUUpdateNumber(GuideNSP,values,names,n);
             //  Update client display
-            IDSetNumber(&GuiderFrameNV,NULL);
-
-            IDLog("GuiderFrame set to %4.0f,%4.0f %4.0f x %4.0f\n",
-                  GuiderFrameN[0].value,GuiderFrameN[1].value,GuiderFrameN[2].value,GuiderFrameN[3].value);
-            GSubX=GuiderFrameN[0].value;
-            GSubY=GuiderFrameN[1].value;
-            GSubW=GuiderFrameN[2].value;
-            GSubH=GuiderFrameN[3].value;
-            return true;
-        }
-
-        if(strcmp(name,GuideNSV.name)==0) {
-            //  We are being asked to send a guide pulse north/south on the st4 port
-            GuideNSV.s=IPS_BUSY;
-            IUUpdateNumber(&GuideNSV,values,names,n);
-            //  Update client display
-            IDSetNumber(&GuideNSV,NULL);
-
-            fprintf(stderr,"GuideNorthSouth set to %7.3f,%7.3f\n",
-                  GuideNS[0].value,GuideNS[1].value);
-
-            if(GuideNS[0].value != 0) {
+            IDSetNumber(GuideNSP,NULL);
+
+            fprintf(stderr,"GuideNorthSouth set to %7.3f,%7.3f\n", GuideNS[0].value,GuideNS[1].value);
+
+            if(GuideNS[0].value != 0)
+            {
                 GuideNorth(GuideNS[0].value);
             }
@@ -342,22 +528,26 @@
             GuideNS[0].value=0;
             GuideNS[1].value=0;
-            GuideNSV.s=IPS_OK;
-            IDSetNumber(&GuideNSV,NULL);
-
-            return true;
-        }
-        if(strcmp(name,GuideEWV.name)==0) {
+            GuideNSP->s=IPS_OK;
+            IDSetNumber(GuideNSP,NULL);
+
+            return true;
+        }
+
+        if(strcmp(name,GuideEWP->name)==0)
+        {
             //  We are being asked to send a guide pulse north/south on the st4 port
-            GuideEWV.s=IPS_BUSY;
-            IUUpdateNumber(&GuideEWV,values,names,n);
+            GuideEWP->s=IPS_BUSY;
+            IUUpdateNumber(GuideEWP,values,names,n);
             //  Update client display
-            IDSetNumber(&GuideEWV,NULL);
+            IDSetNumber(GuideEWP,NULL);
 
             fprintf(stderr,"GuiderEastWest set to %6.3f,%6.3f\n",
                   GuideEW[0].value,GuideEW[1].value);
 
-            if(GuideEW[0].value != 0) {
+            if(GuideEW[0].value != 0)
+            {
                 GuideEast(GuideEW[0].value);
-            } else {
+            } else
+            {
                 GuideWest(GuideEW[1].value);
             }
